/*
 * Copyright 2008, Systemic Realtime Design LLC. All Rights Reserved.
 *
 * This source code may contain confidential information of Systemic
 * Realtime Design LLC and its licensors. Any use, reproduction,
 * modification, disclosure, distribution or transfer of this software,
 * or any software which includes or is based upon any of this code, is
 * prohibited unless expressly authorized by SRD by written agreement. For
 * more information (including whether this source code file has been
 * published) please email licensing@sysrtime.com.
 */

/*****************************************************************************
* Tabs 5 9
* The carets in the following lines will match up if tabs are set properly
*   ^   ^   ^   ^   ^   ^   <== tabs
*   ^   ^   ^   ^   ^   ^   <== spaces
******************************************************************************
*
*   Copyright (C) 2007 Systemic Realtime Design, LLC.    All Rights Reserved.
*
*   This source code may contain confidential information of
*            Systemic Realtime Design, LLC.   (SRD)
*   Any use, reproduction, modification, disclosure, distribution or
*   transfer of this software, or any software which includes or is based
*   upon any of this code, is prohibited unless expressly authorized
*   by SRD by written agreement.
*
*   For more information please email licensing@SysRTime.com.
*
*****************************************************************************/

#ifndef TIPC_TIMER_H
#define TIPC_TIMER_H 1

#include <stdio.h>
#include <inttypes.h>
#include <time.h>


#define jiffies ClockCycles()

unsigned int jiffies_to_msecs (const unsigned long j);


typedef void (*Handler) (unsigned long);

/*
 * TIPC signal code
 */

uint32_t tipc_k_signal(Handler routine, unsigned long arg);


/*
 * TIPC timer code
 */

struct timer_list {
	void                (*function)(void*);
	void                *data;           /* data for timer */
	struct callout      timerRef;
};

void k_init_timer    (struct timer_list *timer, Handler routine, unsigned long arg);
void k_cancel_timer  (struct timer_list *timer);
void k_start_timer   (struct timer_list *timer, unsigned long msec);
void k_term_timer    (struct timer_list *timer);


#endif

